/**
 * Creates a new class with the given attributes
 *
 * @param {object} param
 * @param {string|symbol} param.name name of the class
 *
 * @return {function} the created class
 */
const create = ({ name }) => {
  let createdClass = class {};

  Object.defineProperty(createdClass, 'name', { value: name });

  return createdClass;
};

exports.create = create;
