const { create } = require('../index');

describe('feature: the create function', () => {
  describe('feature: name the created class', () => {
    /**
     * @type {string}
     */
    let myClassName;
    /**
     * @type {function}
     */
    let myClass;
    /**
     * @type {object}
     */
    let myObject;

    beforeEach(() => {
      myClassName = 'myClass';
      myClass = create({ name: myClassName });
      myObject = new myClass();
    });

    it('class name to match', () => {
      expect(myClass.name).toBe(myClassName);
    });

    it('constructor name to match', () => {
      expect(myObject.constructor.name).toBe(myClassName);
    });

    it('instance name to match', () => {
      expect(myObject instanceof myClass);
    });
  });

  describe('feature: name the created class using Symbol', () => {
    /**
     * @type {symbol}
     */
    let myClassSymbol;
    /**
     * @type {function}
     */
    let myClass;
    /**
     * @type {object}
     */
    let myObject;

    beforeEach(() => {
      myClassSymbol = Symbol('myClass');
      myClass = create({ name: myClassSymbol });
      myObject = new myClass();
    });

    it('class name to match', () => {
      expect(myClass.name).toBe(myClassSymbol);
    });

    it('constructor name to match', () => {
      expect(myObject.constructor.name).toBe(myClassSymbol);
    });
  });
});
